# PSA1, Python, vezbe



# Operacije nad brojevima - kalkulator: sabiranje, oduzimanje, mnozenje
2+2
2-3
2*3


# Deljenje (rezultat je uvek float u Pythonu 3)
3/4

# Celobrojno deljenje (floor division)
3//4

3.0/4.0
3.0/4
3./4


#Celobrojno deljenje 1 (ocekivano)
10//3

#Celobrojno deljenje 2 (operand float - rezultat isto float iako je 
# celobrojno deljenje)
10.0//3


#deljenje (ocekivano)
10.0/3

# Celobrojno slucajevi (floor division!!!)
10.0//3.0
-10.0//3.0
-10//3


# Python, type i celobrojno deljenje
# type(x) daje nam kojem tipu pripada x.

# Ali pre toga detaljnije o funkciji type() mozemo dobiti pomocu help():
help(type) 

# Posmatrajmo tipove int i float u svetlu operatora deljenja i celobrojnog
# deljenja
type(3) 
type(3.0) 
type(3.) 
type(10//3) 
type(10.0//3) 
type(10.0/3)
type(10/3.) 
type(10.//3.) 



# Python, stepenovanje
# Paznja! U slucaju da smo navikli da je operator stepenovanja ^ kao kod mnogih 
# programskih jezika! Probajmo da li je 2^3=8?, ...
2^3 
3^2 
3^3 
10^10 


# Dakle, operator stepenovanja u Pythonu nije ^ vec **: 
2**3 
2 ** 3 
3 ** 2 
10 ** 10 
type(10**10) 
3**64 
type(3**3) 
type(3**64)
# Dakle, Python ima samo tip 'int' (nema 'long' sto bi bio ovaj drugi slucaj) 



# Python, % je ostatak pri celobrojnom deljenju
# digresija: PEP - Coding Style guide in Python
10%3 
11%3 
12%3 

# Da primenimo operator % u racunanju vremena; neka je t broj minuta, a mi 
# zelimo da koristimo svakodnevnu komunikaciju gde umesto ukupnog broja 
# minuta (t=66) ili ukupnog broja sati (u=1.1) kazemo koliko sati i koliko 
# minuta:

# t je ukupno minuta:
t=54+12 
print('proteklo je', t, 'minuta')
type(t) 

# Necemo reci ni samo u satima kao sto je slucaj sa promenljivom u (1.1 sat)
u=t/60 
print('proteklo je', u, 'sati')

# Vec preko broja sati, promenljiva s (i celobrojno deljenje //)
s=t//60 

# i ostatak pri deljenju % sto je broj minuta
m=t%60 

print('proteklo je', s, 'sat i', m, 'minuta')



# Python, operatori poredjenja
# jednako
2 == 2 

# Moze i bez razmaka, ali PEP kaze da je sa razmakom preglednije!
2==2 
3 == 2 

# nije jednako
2 != 3 
2 != 2 

# vece, manje, vece ili jednako, manje ili jednako, respektivno:
2 > 3 
2 < 3 
2 >= 1 
2 >= 2 
2 >= 3 
2 <= 1 
2 <= 2 
2 <= 3
# paznja u vezi operatora dodele vrednosti
#3=2 'SyntaxError: can't assign to literal'
#a=3


# Python, logicke operacije
type(True) 
type(False)
a = True
b = False
type(a)
a and b   # logicko i
not a     # logicko ne
a and a
a or not a  # logicko ili
a or (not a)

# ovako se nastavlja red, koristeci '\' (selektovati obe linije, pa onda
# tek pokrenuti!!!)
a or \
not b     



# Python, zapisi brojeva

# Konverzija iz nekog sistema u dekadni:
# Vodeca nula - oznaka brojnog sistema (slovo O, B, X, o, b, x) - broj u tom 
# sistemu

# Izlaz je broj u dekadnom sistemu

# 12 je broj u oktalnom sistemu a izlaz je broj 10 u dekadnom sistemu:
0o12
0O12
0x35
0X35
0b11
0B11



# Python, konverzija zapisa brojeva, konverzija u suprotnu stranu od prethodne:
# konverzija iz dekadnog u neki drugi brojni sistem:
# oznaka brojnog sistema u koji se zeli konvertovati dekadni broj u zagradi;

# Obratiti paznju da je ovde izlaz tipa string!

# 10 je broj u dekadnom sistemu a izlaz je broj 12 u oktalnom sistemu 
# (ali zapisa kao string):
oct(10)
hex(53)
bin(3)



# Python, operacije nad bitima - bitwise operatori; operacije nad brojevima 
# samo se brojevi prikazuju kao skup bita
a = 0b0101
# ovo je zapravo broj:
print(a)

b = 0b0011
# a ovo broj:
print(b)

# & bitwise and (i)
a & b
bin(a & b)

# | bitwise or (ili)
a | b
bin(a | b)

# ^ exclusive or (eksklizivno ili)
a ^ b
bin(a ^ b)

# ~x komplement od x: nule u jedinice i obratno; isto je sto i -x-1
~2
bin(~2)
bin(2)

# x << y pomera sve bite u x levo za y mesta, na kraju dodaje nule
# x << y je isto sto i x pomnozeno sa 2**y 
2 << 1
2 << 4

# x >> y pomera sve bite u x desno za y mesta
# x >> y je isto sto i x celobrojno podeljeno // sa 2**y 
32 >> 2
3 >> 1



# Python, kompleksni brojevi
# literal koji se zavrsava sa j; dakle, samo j ne valja, ali 1j valja!
#j
1j
type(1j)
1j*1j
# moze i veliko slovo, tj. J
2J * 2J
type(1J)

# Kompleksni broj se moze generisati direktno
3 + 4j
# njegova apsolutna vrednost: 
abs(3+4j)

# a moze se definisati i preko funkcije complex()
complex(1,2)

# Moze se pristupati i preko OOP (objektno orijentisano programiranje), gde
# kompleksni broj a posmatramo kao objekat, pa trazimo parametre objakte ili 
# metode nad objektom

a = 2 + 3j
type(a)

# a je objekat tipa kompleksni broj
# a.real - parametar iz objekta a, njegov realni deo
a.real

# a.imag - parametar iz objekta a, njegov imaginarni deo
a.imag


# Hocemo nad objektom da izvrsimo operaciju; kaze se: metod nad objektom
# konjugovano kompleksni broj:
a.conjugate()
a * a.conjugate()

# brisemo nas kompleksni broj a; 
del a

# Ako nakon brisanja pitamo kojeg je tipa:
# type(a)
# javice da nije definisan objekat a!
	


# Python, moduli (moduli koji su deo standardne biblioteke)
# Hocemo npr. da izracunamo sin(1) 
# sin(1)
# sin(1) - javice da nedefinisano ime 'sin'! 
# ili npr. da izracunamo kvadratni koren iz 25
# sqrt(25)
# sqrt(25) - isto ne zna sta je! - ideja modula!

# Modul 'math' - pristup matematickim fukcijama definisanim preko C standarda
import math
type(math)

# dir(ime modula) - sta sve ima od operacija u tom modulu
dir(math)

# pomoc za modul
help(math)

# ili za konkretnu operaciju iz modula (da ne listamo sve)
help(math.sin)

# sada moze sin(x)! x je u radijanima (help)
math.sin(1)

#kao i kvadratni koren...
math.sqrt(25)

#konstante
math.e
math.pi

math.sin(math.pi/2)

# Ojlerova formula: ne radi! modul nema exp za kompleksne brojeve 
# math.exp(math.pi*1j)+1
# ali raspakovano hoce (sa "nulom" kao rezultatom):
math.cos(math.pi) + 1j * math.sin(math.pi) + 1


# Python, namespaces (skraceno ime modula)

# prvo da izbrisemo modul math iz radnog okruzenja:
del math

# Kao sto smo rekli na predavanjima, radi jednostavnosti zapisa, modul se moze 
# importovati i preko namespaces (umesto math zovemo ga skraceno m):
import math as m
m.sin(m.pi / 4)**2
m.exp(1) - m.e
del m

# Ili jos jednostavnije (mada ne i uvek preporucljivo) importovanje, sve iz 
# modula importujemo u radno okruzenje:
 
from math import *

# Sada nema objektno orijentisanog zapisa vec obicno sin, exp...
sin(pi / 4) ** 2
exp(1) - e

# sada moze i Ojlerova jednostavnije
cos(pi) + 1j * sin(pi) + 1

# ali u ovom slucaju ne moze i jednostavno brisanje modula vec sve pojedinacno:
# del pi
# del sin



# Python, operatori dodele (assignment operators)
a = 1
# kad se dodeli vrednost nista se izvrsi u konzoli pa da bismo videli koliko
# je a moramo traziti ispis na standardni izlaz tj. ekran:
print(a)

# Primeri sazetih zapisa kada se rezultat upisuje u jedan od operanada:
# povecaj a za 1 i vrati u a
a += 1
print(a)

# pomnozi a sa 2 i vrati u a
a *= 2
print(a)

# podeli a sa 2 i vrati u a
a /= 2
print(a)

# umanji a za 4 i vrati u a
a -= 4
print(a)

# stepenuj a na 3 i vrati u a
a **= 3
print(a)

# izracunaj ostatak pri deljenju a sa 3 i vrati u a
a %= 3
print(a)

a = 11.0
a //= 3
print(a)		

