# PSA1, Python, vezbe


# Python, funkcije
# primer funkcije 'pdv' koja vraca cenu x sa pdv-om
# zapis: def-kljucna rec (definicija funkcije); pdv-ime funkcije,x-argument
# Paznja! u slucajevima primera sa vise linija selektovati sve linije pa tek 
# onda pokrenuti (F9); dakle, u prvom primeru funkcije selektuju se sve tri
# linije ispod pa tek onda se pokrene izvrsavanje:

def pdv(x):
    y = x * 1.20
    return y

# Sad pozivamo generisanu funkciju koja nam cenu proizvoda u dinarima 
# (u prvom pozivu 100 din) vraca sa pdv-om:
pdv(100)
pdv(150)

# moze i krace (opet selektovani obe linje pa tek onda pokrenuti):
def pdv(x):
    return x * 1.20

# poziv funkcije: poziva se navodjenjem imena funkcije i vednosti argumenta
pdv(100)
pdv(150)

# i 'pdv' je objekat; sve ima svoj type objekta	
type(pdv)		
	


# python, funkcije, help
# help za funkciju koju smo definisali se dodaje kao string odmah ispod
# definisanja funkcije:
def pdv(x):
    'ovo je funkcija koja racuna pdv'
    return x * 1.20

# Ako je sada pozovemo, ne desava se nista posebno:
pdv(100)

# ali se help pojavljuje tek pozivom help(pdv) ispisuje dodati string o 
# definisanoj funkciji kao help
help(pdv)



# Python, funkcije, help u vise redova
# za obimniji help, isti se moze pisati u vise redova; 
# tada se umesto jednog ' na pocetku i kraju stringa koriste tri tj. '''
def pdv(x):
    '''ovo je funkcija koja racuna pdv
	
    a pdv je porez na dodatu vrednost'''
    return x * 1.20

pdv(100)
help(pdv)


# Python, funkcije, opcioni argumenti
# Argumenti funkcije mogu biti obavezni i opcioni;
# Obaveznim argumentima se dodeljuje vrednost prilikom poziva fukcije;
# Opcionim argumentima se prilikom definisanja funkcije dodeljuje 
# podrazumevana vrednost.Prilikom poziva ovom argumentu se ne mora dodeliti
# vrednost jer ce se koristiti podrazumevana.

def pdv(x, stopa = 20):
    return x * (1 + stopa/100)

# Ovde je x obavezni a stopa opcioni argument kome je dodeljena podrazumevana 
# vrednost 20 pa se ona ne koristi pri pozivu funkcije...
pdv(100)
pdv(150)

# ... a moze se koristiti druga vrednost, npr. stopa = 23 pa se tada to 
# naglasava u pozivu; 
# Poziv se moze realizovati pozivanjem opcionog argumenta preko kljucne 
# reci (kwargs - keyword arguments, ovde je to stopa) sa novom vrednoscu...
pdv(100, stopa = 23)

# ... ili samo preko konkretne vrednosti na odgovarajucoj poziciji (bez kljucne
# reci, ali onda moramo paziti da je na dobroj poziciji!)
pdv(100, 23)

# Fukcija moze da vraca i vise vrednosti i tada se one grupisu pomocu malih 
# zagrada kao: return(a, b)

# Brisanje objekta funkcija pdv
del pdv




# Python, kontrola toka; IF struktura
# IF struktura odredjuje koji deo koda se izvrsava u zavisnosti od uslova.
# Digresija:
# Python razdvaja blokove pomocu uvlacenja teksta (a ne viticaste zagrade, 
# kljucne reci, ...). To se primenjuje kod IF strukture, while i for petlje, 
# funkcije (prethodni primeri...)

# Primer: ilustracija strukture IF preko primera ispitivanja parnosti broja 
# (int); primer koriscenja if-else; 
# prvi nacin (selektovati sve linije pa tek onda F9):
def parnost(n):
    if n//2*2 == n:
        print('paran')
    else:
        print('neparan')

# Sada da je pozovemo i vidimo da li radi:
parnost(4)
parnost(5)
parnost(-4)
parnost(-5)
# a sta ako unesemo broj koji nije int?
parnost(4.2)
parnost(5.1)
parnost(4.0)
# Dakle, ovako realizovano daje da se svaki broj koji ima decimalni deo 
# razlicit od 0 vodi kao neparan; dakle, ne radi tacno, trebalo bi realizovati
# da se parnost uopste ne ispituje ako nije ceo broj!


# Primer: ispitivanje parnosti broja (int), drugi nacin:
def parnost(n):
    if n % 2 == 0:
        print('paran')
    else:
        print('neparan')

# Da vidimo radi li sad kako treba:
parnost(4)
parnost(5)
parnost(-4)
parnost(-5)
parnost(4.2)
parnost(5.1)
parnost(4.0)
# Drugacije ali opet ostaje problem ispitivanja broja koji nije ceo broj!


# Python, ispitivanje parnosti broja, primer koriscenja if-elif-else; 
# treci nacin (najzad kako treba):
def parnost(n):
    if type(n) != type(1):
        print("argument nije tipa 'int'")
        return
    elif n//2*2 == n:
        print('paran')
    else:
        print('neparan')

# Testiramo opet:
parnost(4.2)
parnost(4)
parnost(3)
parnost(4.)

# Brisemo funkciju parnost
del parnost


# Python, konverzije tipova i jos ponesto (divmod, pow)

# konverzija broja tipa float u tip int (zaokruzivanje), po definiciji tj. 
# kako Python hoce:
int(-4.2)
int(4.2)

# Ali, postoje i: floor() i ceil() gde se zaokruzuje na najblizi manji i veci 
# ceo broj. Dakle, mozemo i specificirati kakvo zaokruzivanje mi zelimo.
# Ali, ako probamo samo npr. floor(-4.2) nece raditi jer je floor u modulu math, 
# pa najpre moramo pozvati modul math...
# floor(-4.2)

import math
# floor(x) - najveci integer, ne veci od x
math.floor(-4.2)
math.floor(4.2)

# ceil(x) - najmanji integer, ne manji od x
math.ceil(-4.2)
math.ceil(4.2)

# konverzija broja tipa int u tip float
float(5)

# divmod() daje rezultat celobrojnog deljenja i ostatka pri deljenju
divmod(10, 3)
divmod(12, 3)

# dakle, isto sto i
10 // 3
10 % 3
12 // 3
12 % 3

# pow()
pow(2, 8)
# pow (2,8) je isto sto i
2**8

# Visetruke konverzije
str(float(2**8))

type(256)
type(256.0)
type('256')

# Da li je:
256 == 256.0
# iako je jedan tipa int a drugi tipa float, oba su broja, pa ih svodi na
# zajednicki format float i poredi

# ovde su objekti tipa int i tipa string pa ne kovertuje tipove i vraca False 
256 == '256'



# Python, liste
# Liste zovu nizovima u Pythonu ali specificni i drugaciji od nizova u drugim 
# programskim jezicima. Listu čine elementi uzajamno odvojeni zarezima, 
# koji se nalaze unutar uglastih (srednjih) zagrada. Dakle, liste su najblize 
# nizovima ali ne i nizovi onako kako ocekujemo. Elementi liste mogu biti 
# različitog tipa.

a = [1, 2, 5, 6]
# a je objekat tipa list, moze se videti u exploreru, a mozemo i traziti 
# da nam kaze koji je to tip objekta:
type(a)


# Pomoc: klasa list - objekti tipa list
help([])

# Pristupanje elementima liste - indeksiranje krece od nule (paziti zbog 
# Matlaba)!
a[0]
a[1]
a[2]
a[3]
# Sta ako trazimo element liste ciji indeks ne postoji?
#a[4]

# Za razliku od drugih programskih jezika, ovde postoji i pristupanje 
# elementima liste od pozadi:
a[-1]
a[-2]
a[-3]
a[-4]
# Sta ako i sad trazimo element liste ciji indeks ne postoji?
#a[-5]
print(a)

# Broj elemenata u listi, len():
len(a)	

# A sta ako umesto uglastih zagrada stavimo male zagrade? U cemu je razlika? 
a = (1, 2, 5, 6)
# Pogledati koji tip pise u Variable exploreru!

# Moze li se ovde pristupiti elementima?
a[0]
a[1]
a[2]
a[3]

# ili od pozadi:
a[-1]
a[-2]
a[-3]
a[-4]

# Sve isto za sad, ali ipak nije. Ovo je novi objekat tipa tuple:
type(a)

# Razlika izmedju liste i tuple je u tome sto tuple nema tzv. mutability,
# ne mogu mu se menjati pojedini clanovi dok kod liste mogu. Tuple se dakle
# posmatra kao celina.
# Menjamo u listi a element ineksa 2, pa umesto 5 stavljamo 0 i to radi:
a = [1, 2, 5, 6]
a[2]=0
print(a)

# Menjamo u tuple a element ineksa 2, pa umesto 5 stavljamo 0 i to ne radi!
# Dakle, kod liste se mogu menjati pojedini clanovi a kod tuple ne!
a = (1, 2, 5, 6)
a[2]=0


# Python, liste: slicing and mutability
# slicing (podlista): a[i:j] - i je indeks prvog elementa koji ulazi u novu 
# listu a j indeks poslednjeg elementa koji ne ulazi. 
# Dakle, ulaze elementi od ideksa i do indeksa (j-1):
a = [1, 2, 5, 6]
# ovde su to elementi ciji su indeksi a[1] i a[2], tj. drugi i treci (2 i 5)
a[1:3]

# jos neki primeri za slicing:
a[1:2]
a[1:1]
a[1:-2]
a[2:]
a[:2]
a[:-2]

# a[:] cela lista
a[:]

# mutability, vec pokazali, menjamo neki clan...
a[3] = 7
print(a)


# Python, liste, dodavanje i brisanje elemenata
# Da li moze integer da se doda na listu? Da probamo (mozete kucati direktno u
# konzoli ili ovde skloniti # pa probati):
#a + 9

# Dakle, int na listu ne moze, ali moze lista na listu - konkatenacija: 
# produzili listu sa jos jednim elementom (ovako moze):
a + [9]
a = a + [9]
print(a)

# I kod listi vaze i skraceni operatori dodele: 
a +=[9]
print(a)
len(a)

# Moze i sabiranje dve liste, tj. nadovezivanj liste na listu:
b=[2, 3, 4]
print(a+b)

# A moze i umnozavanje liste:
print(b*3)


# Brisanje pojedinih elemenata liste:
del b[1]
print(b)
del b[-1]
print(b)

# brisanje poslednjeg elementa bilo koje liste
del a[(len(a)-1)]
print(a)

# izbrisimo i element indeksa 1
del a[1]
print(a)
# duzina liste a sada je:
len(a)



# Python, liste: metodi append() i extend()
# posmatrajmo listu a (tj. generisimo je):
a = [1, 2, 3, 4]

# append(element) dodaje element na kraj liste:
a.append(5)
print(a)

# dakle, isto kao sto smo ranije radili preko konkatenacije:
a = [1, 2, 3, 4]
a += [5]
print(a)


# Ali, probajmo sada ovo:
b = [6, 7]
a.append(b)
print(a)
len(a)
# ? Ocekivali smo [1, 2, 3, 4, 5, 6, 7] i len(a)=7?!
# Sta je poslednji clan sada u listi a?
a[-1]
# vracamo listu a u prvobitno stanje (brisemo ono sto smo dodali) da probamo 
# i metod extend()
del a[5]
print(a)


# Probajmo sad sa extend():
# extend: listu b dodamo na listu a (preciznije, nastavim listu a listom b) 
a.extend(b)
print(a)
len(a)
# vracamo listu a u prvobitno stanje
del a[5:]
print(a)

# Dakle, razlika append() i extend() je ta sto append() dodaje 1 element liste 
# (koji moze da bude i lista), a extend() produzava listu novim elementima;


# Jos o listama...
# Za razliku od drugih programskih jezika gde su nizovi skupovi elemenata
# istog tipa, u Pythonu lista ne mora sadrzati samo elemente istog tipa. 
# Naravno, zna se koji je prvi, drugi, ... ali ne moraju biti istog tipa. 
# Primer: na listu a dodajemo element tipa string:
a.append('etf')
print(a)
del a[-1]
print(a)


# Python, liste: range()
a = range(5)
len(a)
print(a)
list(range(5))
# Bez obzira sto vam prikazuje range(0, 5) on zna da tu ima 5 elemenata (len 
# to pokaze). Koristi se zarad ustede memorije: dakle, ne pamte se svi elementi, 
# vec prvi, poslednji i korak), preciznije:
# range(start, stop, korak), ovde range(4, 10)
# lista ce najbolje pokazati sta radi komanda range() - generise opseg brojeva 
# od start do (stop-1) sa korakom korak; ako se nista ne kaze korak=1
a = list(range(4, 10))
len(a)
print(a)

# Digresija: Ako je objekat iterable (sekvenca gde se zna sta je prvi, drugi, 
# ... clan), moze se koristiti u for petlji za iteriranje preko sekvence, tj.
# traversing (selektovati obe linije):
for i in a:
    print(i)
    
# Posto je i string iterable, onda i za njega isto vazi. Primer:
s = 'slova'
for i in s:
    print(i)

# Lista sa proredom: opseg od 3 do 10 (bez poslednjeg), a treci clan je 
# inkrement (korak) i on je ovde 2:
a = list(range(3, 10, 2))
print(a)

# Postoji mogucnost i negativnog inkrementa
a = list(range(10, 0, -2))
print(a)		



# Python, stack
# Pojam steka pominjan na predmetima sa RTI;
# Prazna lista:
a = []
type(a)
len(a)
# Prazan stek je prazna lista a!
# append - dodajemo element na stek, broj 1
a.append(1)
print(a)
# dodajemo i sledeci...
a.append(2)
print(a)
a.append(3)
print(a)
# Sa append dakle svaki put dodajemo po jedan element na stek

# pop()- skidamo poslednji element sa steka
a.pop()
print(a)
a.pop()
print(a)
a.pop()
print(a)
# ako nastavimo da skidamo element a lista je prazna? 
# IndexError: pop from empty list
a.pop()


# Definisimo listu range-a 10 (od 0 do 9)
a = list(range(10))
print(a)

# pop(x): skidanje elementa indeksa x sa steka: pop(x) nam vrati trazeni 
# element sa indeksom x i izbrise ga iz liste
a.pop(3)
print(a)
a.pop()
print(a)



# Python, liste: insert()

# Formirajmo prvo listu (od 0 do 9) preko funkcije range();
a = list(range(10))
print(a)
# Sta radi funkcija insert()?
# a.insert(x, y) - insertujemo na mestu ideksa x element y (ostali se pomere 
# na desno):
a.insert(3, 4)
print(a)
a.insert(0, 1)
print(a)

# Insertujemo na kraj - len(a) je poslednje mesto; insertujemo string 'kraj':
a.insert(len(a), 'kraj')
print(a)

# npr. insertujemo kompleksni broj na mestu indeksa 3 u listi a:
a.insert(3, 4 + 5j)
print(a)

# ili npr. insertujemo Bulov broj na mestu 38 u listi a:
a.insert(8, True)
print(a)

# Sve je ovo moguce jer su liste skupovi razlicitih elemenata...
type(a[3])
type(a[-1])
type(a[8])
type(a[0])
type(a)



# Python, liste: reverse(), sort()
# opet cemo koristiti range za formiranje liste
a = list(range(10))
print(a)
# reverse() - okretanje liste naopako:
a.reverse()
print(a)
# i opet naopako vracamo na pocetak:
a.reverse()
print(a)

a.insert(4, 100)
print(a)

# sortiranje liste
a.sort()
print(a)
a = [3, 4, 2, 1]
a.sort()
print(a)
# Specificnost Pythona - neki standardni algoritmi kao sto je ovde sortiranje 
# elemenata niza su vec implementirani (ako ne u bulit-in onda u modulu);
# znaci, sortirke treba da znate ali ne i svaki put da gubite vreme da ih 
# iznova implementirate.


# Python, liste: brojanje (count()) i brisanje (remove());
# formirajmo listu a sledece sadrzine:
a = [3, 2, 3, 1, 4, 3, 2, 2, 5, 2]

# a.count(x) - pokazuje koliko se puta element x pojavljuje u listi
a.count(2)
a.count(3)
a.count('kraj')


# a.remove(x) - uklanja element x iz liste; u slucaju da ih ima vise, uklanja
# onaj koji se nalazi najranije;
# U primeru a.remove(3) uklanja jednu trojku iz liste i to prvu - dakle ide 
# kroz listu od prvog indeksa, naidje na trazeni element, skloni ga i stane - 
# "remove first appearance"
a.remove(3)
a.count(3)
print(a)

# zatim skloni sledecu trojku...
a.remove(3)
print(a)
# i sledecu:
a.remove(3)
print(a)
# koliko je ostalo trojki u listi? Nijedna!
a.count(3)

# Sta se desi ako nastavimo da skidamo trojke iako ih vise nema?
# a.remove(3)



# Python, liste: in operator
# Da prvo vidimo sta je ostalo od liste a
print(a)
# 'x in a' - da li u listi a postoji element x? - odgovor Bulov 
# da li je 3 u listi a?
3 in a
# da li je 2 u listi a?
2 in a
# da li je 4 u listi a?
4 in a
# sad sklonimo 4 iz liste
a.remove(4)
# da li je sada 4 u listi a?
4 in a



# Python, liste: index():
# prvo da vidimo sta nam je ostalo od liste a:
print(a)

# a.index(x) - vraca indeks prvog javljanja elementa x u listi a:
a.index(2)
del a[0]
print(a)
a.index(2)
a.index(5)
a.index(1)
# A sta ako pitamo za indeks nepostojeceg elementa u listi?
# a.index(3)
